// MainView.h : interfaccia della classe CMainView
//

#pragma once

#include <AgtSvr.h>			// supporto per Server Agent
#include "NotifyEx.h"
#include <atlimage.h>

class CMainView : public CView
{
protected: // creare solo da serializzazione.
	CMainView();
	DECLARE_DYNCREATE(CMainView)

// Attributi
public:
	CMainDoc* GetDocument() const;

// Operazioni
protected:
	void DrawLetters(CDC* pDC, int nLetter, COLORREF crBack, CRect rect);
	void AnotherOne();
	void ExplainLetter(int nLetter);

// Sostituzioni
	public:
	virtual void OnDraw(CDC* pDC);  // sottoposto a overriding per creare questa vista
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	
// Implementazione
public:
	virtual ~CMainView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	IAgentEx* m_pAgentEx;
	IAgentCharacterEx* m_pChar;
	CNotifyEx* m_pEvent;
	CImage m_bitImage;
	LONG m_lCharID;
	LONG m_lRequestID;
	LONG m_lEventID;
	CImageList m_imgLetter;
	char m_cLetter[21];
	int m_nOrder[26];

	CRect m_rc[4];
	CRect m_rect;
	int m_nEsatte;
	int m_nFail;
	int m_nCurLetter;
	int m_nNow;
	CString m_strLastQuestion;
		
// Funzioni generate per la mappa dei messaggi
protected:
	DECLARE_MESSAGE_MAP()
	virtual void OnInitialUpdate();
	afx_msg void OnDestroy();
	afx_msg LRESULT OnSpeakComplete(WPARAM wParam, LPARAM lParam);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
};

#ifndef _DEBUG  // versione di debug in MainView.cpp
inline CMainDoc* CMainView::GetDocument() const
   { return reinterpret_cast<CMainDoc*>(m_pDocument); }
#endif

