#pragma once
#include "agtsvr.h"

#define WM_SPEAK_COMPLETE (WM_USER + 1)

#ifndef _AgentNotifySinkEx_h_
#define _AgentNotifySinkEx_h_ 

class CNotifyEx : public IAgentNotifySinkEx
{
public:
	CNotifyEx(){m_dwRef=0;m_pView=NULL;}
	~CNotifyEx(){}

	CWnd* m_pView;

	STDMETHODIMP QueryInterface(REFIID riid, LPVOID FAR* ppvObject);
	STDMETHODIMP_(ULONG) AddRef();
	STDMETHODIMP_(ULONG) Release();

	STDMETHODIMP GetTypeInfoCount(UINT* pctinfo);
	STDMETHODIMP GetTypeInfo(UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo);
	STDMETHODIMP GetIDsOfNames(REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId);
	STDMETHODIMP Invoke(DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT *pVarResult, EXCEPINFO *pExcepInfo, UINT *puArgErr);

    STDMETHODIMP Command(long dwCommandID, IUnknown* punkUserInput);
	STDMETHODIMP ActivateInputState(long dwCharID, long bActivated);
	STDMETHODIMP Restart();
	STDMETHODIMP Shutdown();
	STDMETHODIMP VisibleState(long dwCharID, long bVisible, long dwCause);
	STDMETHODIMP Click(long dwCharID, short fwKeys, long x, long y);
	STDMETHODIMP DblClick(long dwCharID, short fwKeys, long x, long y);
	STDMETHODIMP DragStart(long dwCharID, short fwKeys, long x, long y);
	STDMETHODIMP DragComplete(long dwCharID, short fwKeys, long x, long y);
	STDMETHODIMP RequestStart(long dwRequestID);
	STDMETHODIMP RequestComplete(long dwRequestID, long hrStatus);
	STDMETHODIMP BookMark(long dwBookMarkID);
	STDMETHODIMP Idle(long dwCharID, long bStart);
	STDMETHODIMP Move(long dwCharID, long x, long y, long dwCause);
	STDMETHODIMP Size(long dwCharID, long lWidth, long lHeight);
	STDMETHODIMP BalloonVisibleState(long dwCharID, long bVisible);
	STDMETHODIMP HelpComplete(long dwCharID, long dwCommandID, long dwCause);
	STDMETHODIMP ListeningState(long dwCharID, long bListening, long dwCause);
	STDMETHODIMP DefaultCharacterChange(BSTR bszGUID);
	STDMETHODIMP AgentPropertyChange();
	STDMETHODIMP ActiveClientChange(long dwCharID, long lStatus);
private:
	ULONG m_dwRef;
};

#endif